#ifndef CONFIG_FILE_H
#define CONFIG_FILE_H

#include <linux/adwin.h>

// this config file code is used if we don't use the kernel module
// facility

#ifdef __cplusplus
extern "C" {
#endif

// note that device is an index in the device table, not the device
// number
int findDevice(int device);
adwin_dev_t getDevice(int device);
void clearDevice(adwin_dev_t *dev);
void addDeviceCF(adwin_dev_t dev);
void deleteDeviceCF(int device);
void reloadConfigFile();
void printDeviceConfig(FILE *fd, adwin_dev_t dev);
void printConfig(FILE *fd);
int existsConfigFile();
int getAdwindir(char *adwindir);
int getDeviceCount();

#ifdef __cplusplus
}
#endif

#endif // CONFIG_FILE_H
