#ifndef __LIBADWIN_UNDOCUMENTED_H__
#define __LIBADWIN_UNDOCUMENTED_H__

#include <sys/cdefs.h>
#include <sys/types.h>
#include "linux/adwin.h"
#include "libadwin/bits.h"

#include <inttypes.h>

#ifdef __cplusplus
extern "C" {
#endif

extern int SETMUTEX(int device, adwin_dev_t *vd);
extern int SETMUTEX_INIT_GEN_DRIVER (int device, adwin_dev_t *vd);
extern void CLEARMUTEX(adwin_dev_t *vd, int fd);

typedef struct _DeviceNumber {
    int32_t DeviceNo;
    int32_t DeviceType;
    int32_t ServerVersion;
    time_t  LastAccessTime;
} DeviceNumber;

DeviceNumber *__adwin_deviceno_location(void);

#define CURRENTDEVICE (*(__adwin_deviceno_location ()))

typedef struct {
    int __errno;
    char *__errstr;
} adwin_errlist_t;

extern adwin_errlist_t adwin_errlist[];
extern char VersionString[];

extern int16_t Get_Known_Deviceno(int32_t devices[], int32_t *count_devices);
extern int32_t Get_Connection_Type(int16_t device_no);
extern int32_t Get_Globaldelay (int32_t ProcessNo);
extern int Get_IP_Address(char* buf, int16_t device_no);
extern int Get_Port(int16_t device_no);
extern int Get_Timeout(int16_t device_no);
extern void Get_Memory_dsp(int32_t base_addr, int32_t count, int32_t *dest);

extern char *libadwin_version(void);

#define check_type(type) check_type_loc(__FILE__, __LINE__, type)
#define check_system_type(type) check_system_type_loc(__FILE__, __LINE__, type)

extern int check_type_loc(const char *file, int line, adwin_data_type_t type);
extern int check_system_type_loc(const char *file, int line, adwin_system_data_type_t asdt);


extern adwin_system_data_type_t to_system_type(adwin_data_type_t adt);

/* extern adwin_data_type_t map_system_to_official_data_type(adwin_system_data_type_t system_type); */

extern int _Set_Data(int32_t data_no, void *src, adwin_data_type_t adt,
                     int32_t start_index, int32_t count, int32_t device_no, int do_convert);
extern int _Get_Data(int32_t data_no, void *dest, adwin_data_type_t adt,
                     int32_t start_index, int32_t count, int32_t device_no, int do_convert);
extern int _Set_Fifo(int32_t fifo_no, void *src, adwin_data_type_t adt,
                     int32_t count, int32_t device_no);
extern int _Get_Fifo(int32_t fifo_no, void *dest, adwin_data_type_t adt,
                     int32_t count, int32_t device_no);

extern int adwin_set_processdelay(int process, int delay, int id);

extern int adwin_get_processdelay(int process, int id);

extern int __adwin_get_processdelay(int process, int *err, int id);

extern int32_t Set_GD_Transsize(int32_t value, int16_t nadr);
extern int32_t Get_GD_Transsize(int16_t nadr);

#ifdef __cplusplus
}
#endif

#endif /* __LIBADWIN_UNDOCUMENTED_H__ */
